unit CreatorUnit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, Buttons, ComCtrls, Tabnotbk, Screendialog, Spin,
  ExtDlgs, SelectImage, TextUnit, FontTextUnit;

type
  TCreatorForm = class(TForm)
    ListBox: TListBox;
    NewListButton: TBitBtn;
    LoadListButton: TBitBtn;
    SaveListButton: TBitBtn;
    Bevel1: TBevel;
    OpenListDialog: TOpenDialog;
    SaveListDialog: TSaveDialog;
    Bevel2: TBevel;
    ScreenBox: TListBox;
    Label1: TLabel;
    Label2: TLabel;
    Label4: TLabel;
    Panel1: TPanel;
    AddAction: TBitBtn;
    NewScreenButton: TBitBtn;
    OpenPictureDialog: TOpenPictureDialog;
    ColorDialog: TColorDialog;
    Notebook: TTabbedNotebook;
    Label3: TLabel;
    KommentarEdit: TEdit;
    Memo1: TMemo;
    Label5: TLabel;
    LightBar: TTrackBar;
    Memo2: TMemo;
    Label6: TLabel;
    RadioGroup1: TRadioGroup;
    FadeIn: TRadioButton;
    FadeOut: TRadioButton;
    FadeBar: TTrackBar;
    Memo3: TMemo;
    FontTextoutButton: TBitBtn;
    TextoutButton: TButton;
    Bevel3: TBevel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Shape1: TShape;
    Shape2: TShape;
    Shape3: TShape;
    Shape4: TShape;
    Shape5: TShape;
    Shape6: TShape;
    Shape7: TShape;
    Shape8: TShape;
    xEdit: TSpinEdit;
    yEdit: TSpinEdit;
    Memo4: TMemo;
    Bevel5: TBevel;
    PaintBitmapImage: TImage;
    ColorShape: TShape;
    Label11: TLabel;
    Label12: TLabel;
    OpenImageButton: TBitBtn;
    Memo5: TMemo;
    Bevel4: TBevel;
    BildImage: TImage;
    LoadImageButton: TBitBtn;
    Memo6: TMemo;
    Label13: TLabel;
    FrameLabel: TLabel;
    Label14: TLabel;
    xPosLabel: TLabel;
    openAnimateButton: TBitBtn;
    AnimateTimeBar: TScrollBar;
    AnimateXPosBar: TScrollBar;
    Memo7: TMemo;
    TimeBevel: TBevel;
    analogLabel: TLabel;
    TimePosLabel: TLabel;
    RadioGroup2: TRadioGroup;
    analogButton: TRadioButton;
    digitalButton: TRadioButton;
    TimePosBar: TScrollBar;
    Memo8: TMemo;
    Memo9: TMemo;
    AddScreenButton: TBitBtn;
    Bevel6: TBevel;
    Label15: TLabel;
    CPUMONButton: TBitBtn;
    ExitButton: TBitBtn;
    ScreenTimeEdit: TSpinEdit;
    Label17: TLabel;
    Label16: TLabel;
    Label18: TLabel;
    CPUMONCHARButton: TBitBtn;
    Label19: TLabel;
    RAMMONButton: TBitBtn;
    Label20: TLabel;
    RAMMONCHARButton: TBitBtn;
    Label21: TLabel;
    PrintersButton: TBitBtn;
    DrivesButton: TBitBtn;
    ExtLstButton: TBitBtn;
    Bevel7: TBevel;
    HintMemo: TMemo;
    procedure LoadListButtonClick(Sender: TObject);
    procedure SaveListButtonClick(Sender: TObject);
    procedure NewListButtonClick(Sender: TObject);
    procedure NewScreenButtonClick(Sender: TObject);
    procedure AddActionClick(Sender: TObject);
    procedure FadeBarChange(Sender: TObject);
    procedure ScreenBoxKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure Shape2MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Shape3MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Shape4MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Shape1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Shape6MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Shape7MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Shape8MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Shape5MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure LoadImageButtonClick(Sender: TObject);
    procedure OpenImageButtonClick(Sender: TObject);
    procedure PaintBitmapImageMouseUp(Sender: TObject;
      Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure ColorShapeMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Button1Click(Sender: TObject);
    procedure openAnimateButtonClick(Sender: TObject);
    procedure AnimateTimeBarChange(Sender: TObject);
    procedure AnimateXPosBarChange(Sender: TObject);
    procedure TimePosBarChange(Sender: TObject);
    procedure analogButtonClick(Sender: TObject);
    procedure analogButtonKeyPress(Sender: TObject; var Key: Char);
    procedure digitalButtonClick(Sender: TObject);
    procedure digitalButtonKeyPress(Sender: TObject; var Key: Char);
    procedure TextoutButtonClick(Sender: TObject);
    procedure FontTextoutButtonClick(Sender: TObject);
    procedure ListBoxClick(Sender: TObject);
    procedure AddScreenButtonClick(Sender: TObject);
    procedure ExitButtonClick(Sender: TObject);
    procedure ListBoxKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure CPUMONButtonClick(Sender: TObject);
    procedure CPUMONCHARButtonClick(Sender: TObject);
    procedure RAMMONButtonClick(Sender: TObject);
    procedure RAMMONCHARButtonClick(Sender: TObject);
    procedure PrintersButtonClick(Sender: TObject);
    procedure DrivesButtonClick(Sender: TObject);
    procedure ExtLstButtonClick(Sender: TObject);
    procedure FormMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure ListBoxMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure ExtLstButtonMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure ScreenBoxMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure NewScreenButtonMouseMove(Sender: TObject; Shift: TShiftState;
      X, Y: Integer);
    procedure AddScreenButtonMouseMove(Sender: TObject; Shift: TShiftState;
      X, Y: Integer);
    procedure AddActionMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure ExitButtonMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure NewListButtonMouseMove(Sender: TObject; Shift: TShiftState;
      X, Y: Integer);
    procedure SaveListButtonMouseMove(Sender: TObject; Shift: TShiftState;
      X, Y: Integer);
    procedure LoadListButtonMouseMove(Sender: TObject; Shift: TShiftState;
      X, Y: Integer);
    procedure CPUMONButtonMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure CPUMONCHARButtonMouseMove(Sender: TObject;
      Shift: TShiftState; X, Y: Integer);
    procedure RAMMONButtonMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure RAMMONCHARButtonMouseMove(Sender: TObject;
      Shift: TShiftState; X, Y: Integer);
    procedure PrintersButtonMouseMove(Sender: TObject; Shift: TShiftState;
      X, Y: Integer);
    procedure DrivesButtonMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
  private
    { Private-Deklarationen }
    procedure ShowHint(Nr: byte);
  public
    { Public-Deklarationen }
  end;

var
  CreatorForm: TCreatorForm;
  HintNr: byte; //fr ShowHint, damit HintMemo nicht neu geschrieben wird wenn nicht ntig

implementation

{$R *.DFM}

procedure TCreatorForm.LoadListButtonClick(Sender: TObject);
begin
     openlistdialog.InitialDir:=extractfilepath(application.ExeName)+'Lists\';
     if openlistdialog.execute then begin
      listbox.items.loadfromfile(openlistdialog.filename);
      NewScreenButton.enabled:=true;
      Label16.Enabled:=true;
      Label17.Enabled:=true;
      Label18.Enabled:=true;
      Label19.Enabled:=true;
      Label20.Enabled:=true;
      Label21.Enabled:=true;
      ScreenTimeEdit.Enabled:=true;
      DrivesButton.Enabled:=true;
      PrintersButton.Enabled:=true;
      ExtLstButton.Enabled:=true;
      CPUMONButton.Enabled:=true;
      CPUMONCHARButton.Enabled:=true;
      RAMMONButton.Enabled:=true;
      RAMMONCHARButton.Enabled:=true;
      SaveListButton.Enabled:=true;
     end;
end;

procedure TCreatorForm.SaveListButtonClick(Sender: TObject);
begin
     if savelistdialog.execute then begin
      //wenn Dateiendung <> *.lst, dann:
      if copy(savelistdialog.filename,length(savelistdialog.filename)-3,4) <>'.lst' then
        savelistdialog.filename:=savelistdialog.filename+'.lst';
      //und speichern
      listbox.items.savetofile(savelistdialog.filename);
     end;
end;

procedure TCreatorForm.NewListButtonClick(Sender: TObject);
begin
     listbox.Items.Clear;
     NewScreenButton.enabled:=true;
     Label16.Enabled:=true;
     Label17.Enabled:=true;
     Label18.Enabled:=true;
     Label19.Enabled:=true;
     Label20.Enabled:=true;
     Label21.Enabled:=true;
     ScreenTimeEdit.Enabled:=true;
     DrivesButton.Enabled:=true;
     PrintersButton.Enabled:=true;
     ExtLstButton.Enabled:=true;
     CPUMONButton.Enabled:=true;
     CPUMONCHARButton.Enabled:=true;
     RAMMONButton.Enabled:=true;
     RAMMONCHARButton.Enabled:=true;
     SaveListButton.Enabled:=true;
     
end;

procedure TCreatorForm.NewScreenButtonClick(Sender: TObject);
var
   SelScreens: byte;
begin
     //Default-Einstellungen
     NewScreenDialog.TitleEdit.Text:='Neuer Screen';
     NewScreenDialog.CheckBox1.checked:=true;
     NewScreenDialog.CheckBox2.checked:=true;
     NewScreenDialog.CheckBox3.checked:=true;
     NewScreenDialog.CheckBox4.checked:=true;
     NewScreenDialog.ScreenTimeEdit.Value:=200;
     NewScreenDialog.RadioButton1.Checked:=true;
     //Fenster anzeigen
     NewScreenDialog.showmodal;
     //Notebook enablen
     Notebook.enabled:=true;
     //Screenbox leeren
     ScreenBox.Items.clear;

     //Titel
     screenbox.items.add(';'+NewScreenDialog.TitleEdit.Text);
     //NEWSCREEN
     screenbox.items.add('NEWSCREEN');
     //Screens
     if NewScreenDialog.CheckBox2.checked then SelScreens:=1
     else SelScreens:=0;
     if NewScreenDialog.CheckBox1.checked then SelScreens:=SelScreens+2;
     screenbox.Items.add('SELECTSCREEN '+inttostr(SelScreens));
     //Cleared Screens
     if NewScreenDialog.CheckBox3.checked then screenbox.Items.add('CLEARSCREEN 1');
     if NewScreenDialog.CheckBox4.checked then screenbox.Items.add('CLEARSCREEN 2');
     //Helligkeit
     if NewScreenDialog.RadioButton1.checked then screenbox.Items.add('LIGHT 1')
     else if NewScreenDialog.RadioButton2.checked then screenbox.Items.add('LIGHT 2')
     else if NewScreenDialog.RadioButton3.checked then screenbox.Items.add('LIGHT 3')
     else if NewScreenDialog.RadioButton4.checked then screenbox.Items.add('LIGHT 4')
     else if NewScreenDialog.RadioButton5.checked then screenbox.Items.add('LIGHT 5')
     else if NewScreenDialog.RadioButton6.checked then screenbox.Items.add('LIGHT 6')
     else if NewScreenDialog.RadioButton7.checked then screenbox.Items.add('LIGHT 7')
     else if NewScreenDialog.RadioButton8.checked then screenbox.Items.add('LIGHT 8');
     //ScreenDauer
     screenbox.items.add('SCREENTIME '+inttostr(NewScreenDialog.ScreenTimeEdit.Value));
     //Screenende
     screenbox.items.add('SCREENEND');

     notebook.PageIndex:=0;
     notebook.Visible:=true;
     panel1.visible:=true;
     label4.visible:=true;
     AddScreenButton.Enabled:=true;
end;

procedure TCreatorForm.AddActionClick(Sender: TObject);
var
   PB: Byte;
   p1,p2,p3,p4,p5,p6: string;
begin
     case notebook.PageIndex of
      0: begin
          ScreenBox.Items.Insert(ScreenBox.Items.Count-2,';'+KommentarEdit.Text);
          KommentarEdit.Text:='';
         end;
      1: begin
          ScreenBox.Items.Insert(ScreenBox.Items.Count-2,'LIGHT '+inttostr(LightBar.position));
          LightBar.position:=1;
         end;
      2: begin
          if FadeIn.checked then ScreenBox.Items.Insert(ScreenBox.Items.Count-2,'FADEIN '+inttostr(FadeBar.position))
          else ScreenBox.Items.Insert(ScreenBox.Items.Count-2,'FADEOUT '+inttostr(FadeBar.position));
          FadeBar.position:=500;
          Label6.Caption:='Geschwindigkeit:';
         end;
      3: begin
          if TextForm.TextEdit.Text<>'' then begin
           //Spalte (zweistellig)
           p1:=inttostr(TextForm.SpalteEdit.Value-1);
           while length(p1)<2 do
            p1:='0'+p1;
           //Zeile (zweistellig)
           p2:=inttostr(TextForm.ZeilenEdit.Value-1);
           while length(p2)<2 do
            p2:='0'+p2;
           ScreenBox.Items.Insert(ScreenBox.Items.Count-2,'PAINTSTRING '+''''+TextForm.TextEdit.Text+''''+' '+p1+' '+p2)
          end
          else if FontTextForm.TextEdit.Text<>'' then begin
           //xPos (dreistellig)
           p1:=inttostr(FontTextForm.xEdit.Value);
           while length(p1)<3 do
            p1:='0'+p1;
           //yPos (zweistellig)
           p2:=inttostr(FontTextForm.yEdit.Value);
           while length(p2)<2 do
            p2:='0'+p2;
           //Fonthhe (zweistellig)
           p3:=inttostr(FontTextForm.FontDialog.Font.Size);
           while length(p3)<2 do
            p3:='0'+p3;
           //Fontname
           p4:=FontTextForm.FontDialog.Font.Name;

           ScreenBox.Items.Insert(ScreenBox.Items.Count-2,'TEXTOUT '+''''+FontTextForm.TextEdit.Text+''''+' '+p1+' '+p2+' '+p3+' '+p4)
          end;
          TextForm.TextEdit.Text:='';
          FontTextForm.TextEdit.Text:='';
         end;
      4: begin
          PB:=0;
          if shape1.brush.color=clAqua then PB:=PB+128;
          if shape2.brush.color=clAqua then PB:=PB+64;
          if shape3.brush.color=clAqua then PB:=PB+32;
          if shape4.brush.color=clAqua then PB:=PB+16;
          if shape5.brush.color=clAqua then PB:=PB+8;
          if shape6.brush.color=clAqua then PB:=PB+4;
          if shape7.brush.color=clAqua then PB:=PB+2;
          if shape8.brush.color=clAqua then PB:=PB+1;
          //PixelByte
          p1:=inttostr(PB);
          while length(p1)<3 do
           p1:='0'+p1;
          //xPos
          p2:=inttostr(xEdit.Value);
          while length(p2)<3 do
           p2:='0'+p2;
          //yPos
          p3:=inttostr(yEdit.Value);

          ScreenBox.Items.Insert(ScreenBox.Items.Count-2,'PIXELBYTE '+p1+' '+p2+' '+p3);
          xEdit.Value:=0;
          yEdit.Value:=0;
         end;
      5: begin
          //Filename
          p1:=openpicturedialog.filename+'?';
          if p1<>'?' then begin
           //xPos
           p2:=inttostr(Imageform.xPosBar.Position);
           while length(p2)<3 do
            p2:='0'+p2;
           //yPos
           p3:=inttostr(ImageForm.yPosBar.Position);
           //Width
           p4:=inttostr(ImageForm.widthBar.Position-1);
           while length(p4)<3 do
            p4:='0'+p4;
           //xOffset
           p5:=inttostr(ImageForm.OffsetBar.Position);
           while length(p5)<3 do
            p5:='0'+p5;
           //Farbe
           p6:=colortostring(ColorShape.Brush.Color);

           ScreenBox.Items.Insert(ScreenBox.Items.Count-2,'PAINTBITMAP '+p1+' '+p2+' '+p3+' '+p4+' '+p5+' '+p6);
           OpenPictureDialog.Filename:='';
           ColorShape.Brush.Color:=clBlack;
           PaintBitmapImage.Picture.bitmap.canvas.pen.color:=clWhite;
           PaintBitmapImage.Picture.bitmap.canvas.fillrect(PaintBitmapImage.clientrect);
          end else application.MessageBox('Bitte erst ein Bild ffnen!','Da fehlt doch was!',0);
         end;
      6: begin
          if openPictureDialog.filename<>'' then
           ScreenBox.Items.Insert(ScreenBox.Items.Count-2,'STRETCHBITMAP '+OpenPictureDialog.FileName);
          OpenPictureDialog.Filename:='';
         end;
      7: begin
          if openPictureDialog.filename<>'' then begin
           //Animationsinterval
           p1:=inttostr(AnimateTimeBar.position);
           //XPosition (dreistellig)
           p2:=inttostr(AnimateXPosBar.position);
           while length(p2)<3 do
            p2:='0'+p2;
           ScreenBox.Items.Insert(ScreenBox.Items.Count-2,'ANIMATE '+OpenPictureDialog.FileName+' '+p2+' '+p1);
          end; //if
          OpenPictureDialog.Filename:='';
          AnimateTimeBar.position:=500;
          AnimateXPosBar.position:=0;
         end;
      8: begin
           if analogButton.checked=true then begin
             //xPosition (dreistellig)
             p1:=inttostr(TimePosBar.position);
             while length(p1)<3 do
              p1:='0'+p1;
             ScreenBox.Items.Insert(ScreenBox.Items.Count-2,'TIME ANALOG '+p1);
           end else begin
             ScreenBox.Items.Insert(ScreenBox.Items.Count-2,'TIME DIGITAL 000');
           end;
           analogButton.checked:=false;
           digitalButton.checked:=true;
           TimePosLabel.visible:=false;
           TimePosBar.visible:=false;
           TimePosBar.position:=0;
           analogLabel.visible:=false;
           TimeBevel.visible:=false;
         end;





     end; //case of
end;

procedure TCreatorForm.FadeBarChange(Sender: TObject);
begin
     Label6.caption:='Geschwindigkeit: '+floattostr(FadeBar.position/1000)+' Sek./Schritt';
end;

procedure TCreatorForm.ScreenBoxKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
     //wenn 'Entf' (KeyCode 46) gedrckt wurde und ein Element gewhlt ist, dann...
     if (key=46) then begin
      if (screenbox.itemindex>1) and (screenbox.itemindex<screenbox.items.count-2) then screenbox.Items.Delete(screenbox.itemindex)
      else application.messagebox('Darf nicht gelscht werden!','Halt',0);
     end;
end;

procedure TCreatorForm.Shape1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
     with shape1.brush do
      if color=clblack then color:=clAqua
      else color:=clblack;
end;

procedure TCreatorForm.Shape2MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
     with shape2.brush do
      if color=clblack then color:=clAqua
      else color:=clblack;
end;

procedure TCreatorForm.Shape3MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
     with shape3.brush do
      if color=clblack then color:=clAqua
      else color:=clblack;
end;

procedure TCreatorForm.Shape4MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
     with shape4.brush do
      if color=clblack then color:=clAqua
      else color:=clblack;
end;

procedure TCreatorForm.Shape5MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
     with shape5.brush do
      if color=clblack then color:=clAqua
      else color:=clblack;
end;

procedure TCreatorForm.Shape6MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
     with shape6.brush do
      if color=clblack then color:=clAqua
      else color:=clblack;
end;

procedure TCreatorForm.Shape7MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
     with shape7.brush do
      if color=clblack then color:=clAqua
      else color:=clblack;
end;

procedure TCreatorForm.Shape8MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
     with shape8.brush do
      if color=clblack then color:=clAqua
      else color:=clblack;
end;


procedure TCreatorForm.LoadImageButtonClick(Sender: TObject);
begin
     openpicturedialog.InitialDir:=extractfilepath(application.exename);
     if openpicturedialog.execute then begin
        BildImage.Picture.LoadFromFile(openPictureDialog.filename);
     end;
end;


procedure TCreatorForm.OpenImageButtonClick(Sender: TObject);
begin
     openpicturedialog.InitialDir:=extractfilepath(application.exename);
     if openpicturedialog.Execute then begin
      ImageForm.Image1.Picture.LoadFromFile(openPictureDialog.filename);
      ImageForm.Image.Picture.LoadFromFile(openPictureDialog.filename);
      ImageForm.Image.width:=ImageForm.Image.Picture.width;
      ImageForm.Image.height:=ImageForm.Image.Picture.height;
      ImageForm.xPosBar.position:=0;
      ImageForm.yPosBar.position:=0;
      ImageForm.OffsetBar.max:=ImageForm.Image.Picture.width;
      ImageForm.widthBar.position:=256;
      ImageForm.ShowModal;
      PaintBitmapImage.Picture.Assign(ImageForm.Image1.Picture);
     end;
end;

procedure TCreatorForm.PaintBitmapImageMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
     ColorShape.Brush.Color:=PaintBitmapImage.Canvas.Pixels[X,Y];
end;

procedure TCreatorForm.ColorShapeMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
     if ColorDialog.execute then ColorShape.Brush.Color:=ColorDialog.Color;
end;

procedure TCreatorForm.Button1Click(Sender: TObject);
begin
     screenbox.items.SaveToFile('c:\delphi\test\vfd-studio\lists\screen.lst');
end;

procedure TCreatorForm.openAnimateButtonClick(Sender: TObject);
var
   Frames: Integer;
begin
     openpicturedialog.InitialDir:=extractfilepath(application.exename);
     if openPictureDialog.execute then begin
      try
        Frames:=strtoint(copy(extractfilename(openPictureDialog.filename),0,2));
      except
        openPictureDialog.filename:='';
        application.MessageBox('Der Dateiname mu mit der Anzahl der Frames beginnen! Beispiel: ''30globus.bmp''','Fehlerhafter Dateiname',0);
      end;
     end;
end;

procedure TCreatorForm.AnimateTimeBarChange(Sender: TObject);
begin
     FrameLabel.caption:=floattostr(round(100000/AnimateTimeBar.Position)/ 100)+' Frames/Sek.';
end;

procedure TCreatorForm.AnimateXPosBarChange(Sender: TObject);
begin
     xposLabel.caption:=inttostr(AnimateXPosBar.position);
end;

procedure TCreatorForm.TimePosBarChange(Sender: TObject);
begin
     TimePosLabel.caption:=inttostr(TimePosBar.position);
end;

procedure TCreatorForm.analogButtonClick(Sender: TObject);
begin
     TimePosLabel.visible:=analogButton.checked;
     TimePosBar.visible:=analogButton.checked;
     analogLabel.visible:=analogButton.checked;
     TimeBevel.visible:=analogButton.checked;
end;

procedure TCreatorForm.analogButtonKeyPress(Sender: TObject;
  var Key: Char);
begin
     TimePosLabel.visible:=analogButton.checked;
     TimePosBar.visible:=analogButton.checked;
     analogLabel.visible:=analogButton.checked;
     TimeBevel.visible:=analogButton.checked;
end;

procedure TCreatorForm.digitalButtonClick(Sender: TObject);
begin
     TimePosLabel.visible:=analogButton.checked;
     TimePosBar.visible:=analogButton.checked;
     analogLabel.visible:=analogButton.checked;
     TimeBevel.visible:=analogButton.checked;
end;

procedure TCreatorForm.digitalButtonKeyPress(Sender: TObject;
  var Key: Char);
begin
     TimePosLabel.visible:=analogButton.checked;
     TimePosBar.visible:=analogButton.checked;
     TimeBevel.visible:=analogButton.checked;
     analogLabel.visible:=analogButton.checked;
end;

procedure TCreatorForm.TextoutButtonClick(Sender: TObject);
begin
     TextForm.TextEdit.Text:='';
     TextForm.SpalteEdit.Value:=1;
     TextForm.ZeilenEdit.Value:=1;
     TextForm.ShowModal;
end;

procedure TCreatorForm.FontTextoutButtonClick(Sender: TObject);
begin
     FontTextForm.TextEdit.Text:='';
     FontTextForm.xEdit.Value:=0;
     FontTextForm.yEdit.Value:=0;
     FontTextForm.ShowModal;
end;

procedure TCreatorForm.ListBoxClick(Sender: TObject);
var
   LI: Integer;
begin
     //an Blockanfang springen
     LI:=ListBox.ItemIndex;
     while (ListBox.Items[LI]<>'NEWSCREEN') and (LI>0) do
      dec(LI);

     if LI>0 then dec(LI);  //weiteres mal dekrementieren wg. ScreenTitel

     ListBox.ItemIndex:=LI;


end;

procedure TCreatorForm.AddScreenButtonClick(Sender: TObject);
var
   i: Integer;
begin
     if (ListBox.ItemIndex>-1) or (ListBox.Items.Count>=0) then begin
      //ScreenBoxStrings zu ListBox hinzufgen
      for i:=0 to ScreenBox.Items.Count-1 do
       ListBox.Items.Insert(ListBox.ItemIndex,ScreenBox.Items[i]);
      ListBox.Items.Insert(ListBox.ItemIndex,'');  //+ eine Leerzeile
     end else application.MessageBox('Bitte erst die Position in der Liste markieren, wo eingefgt werden soll.','Und wohin damit?',0);
end;

procedure TCreatorForm.ExitButtonClick(Sender: TObject);
begin
     CreatorForm.Close;
end;

procedure TCreatorForm.ListBoxKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var
   SE, i, index: Integer;
   S: String;

begin
     //wenn 'Entf' (KeyCode 46) gedrckt wurde und ein Screen gewhlt ist, dann...
     if (key=46) then begin
      if (ListBox.ItemIndex>-1) then begin

       //Ende des Blockes ermitteln
       SE:=ListBox.ItemIndex-1;
       index:=ListBox.ItemIndex;
       repeat
        inc(SE);
        S:=ListBox.Items[SE];
       until (S='SCREENEND') or (pos('LOADSCREEN',S)=1) or (SE>=ListBox.Items.count-1);
       //Block lschen
       for i:=ListBox.ItemIndex to SE+1 do begin
        ListBox.ItemIndex:=index;
        ListBox.Items.delete(index);
       end;

      end; //if Screen markiert

     end; //if key=46

end;

procedure TCreatorForm.CPUMONButtonClick(Sender: TObject);
begin
     if (ListBox.ItemIndex>-1) or (ListBox.Items.Count>=0) then begin
      //in Liste hinzufgen:
      ListBox.Items.Insert(ListBox.ItemIndex,';Verlauf der CPU-Nutzung in den letzten 8.5 Minuten');
      ListBox.Items.Insert(ListBox.ItemIndex,'NEWSCREEN');
      ListBox.Items.Insert(ListBox.ItemIndex,'SELECTSCREEN 3');
      ListBox.Items.Insert(ListBox.ItemIndex,'CLEARSCREEN 1');
      ListBox.Items.Insert(ListBox.ItemIndex,'CLEARSCREEN 2');
      ListBox.Items.Insert(ListBox.ItemIndex,'LIGHT 1');
      ListBox.Items.Insert(ListBox.ItemIndex,'CPUMONITOR');
      ListBox.Items.Insert(ListBox.ItemIndex,'SCREENTIME '+inttostr(ScreenTimeEdit.Value));
      ListBox.Items.Insert(ListBox.ItemIndex,'SCREENEND');
      ListBox.Items.Insert(ListBox.ItemIndex,'');  //+ eine Leerzeile
     end else application.MessageBox('Bitte erst die Position in der Liste markieren, wo eingefgt werden soll.','Und wohin damit?',0);
end;

procedure TCreatorForm.CPUMONCHARButtonClick(Sender: TObject);
begin
     if (ListBox.ItemIndex>-1) or (ListBox.Items.Count>=0) then begin
      //in Liste hinzufgen:
      ListBox.Items.Insert(ListBox.ItemIndex,';Verlauf der CPU-Nutzung in den letzten 1.5 Mintuten');
      ListBox.Items.Insert(ListBox.ItemIndex,'NEWSCREEN');
      ListBox.Items.Insert(ListBox.ItemIndex,'SELECTSCREEN 3');
      ListBox.Items.Insert(ListBox.ItemIndex,'CLEARSCREEN 1');
      ListBox.Items.Insert(ListBox.ItemIndex,'CLEARSCREEN 2');
      ListBox.Items.Insert(ListBox.ItemIndex,'LIGHT 1');
      ListBox.Items.Insert(ListBox.ItemIndex,'CPUMONCHAR');
      ListBox.Items.Insert(ListBox.ItemIndex,'SCREENTIME '+inttostr(ScreenTimeEdit.Value));
      ListBox.Items.Insert(ListBox.ItemIndex,'SCREENEND');
      ListBox.Items.Insert(ListBox.ItemIndex,'');  //+ eine Leerzeile
     end else application.MessageBox('Bitte erst die Position in der Liste markieren, wo eingefgt werden soll.','Und wohin damit?',0);
end;

procedure TCreatorForm.RAMMONButtonClick(Sender: TObject);
begin
     if (ListBox.ItemIndex>-1) or (ListBox.Items.Count>=0) then begin
      //in Liste hinzufgen:
      ListBox.Items.Insert(ListBox.ItemIndex,';Verlauf der RAM-Nutzung der letzten 8.5 Minuten');
      ListBox.Items.Insert(ListBox.ItemIndex,'NEWSCREEN');
      ListBox.Items.Insert(ListBox.ItemIndex,'SELECTSCREEN 3');
      ListBox.Items.Insert(ListBox.ItemIndex,'CLEARSCREEN 1');
      ListBox.Items.Insert(ListBox.ItemIndex,'CLEARSCREEN 2');
      ListBox.Items.Insert(ListBox.ItemIndex,'LIGHT 1');
      ListBox.Items.Insert(ListBox.ItemIndex,'RAMMONITOR');
      ListBox.Items.Insert(ListBox.ItemIndex,'SCREENTIME '+inttostr(ScreenTimeEdit.Value));
      ListBox.Items.Insert(ListBox.ItemIndex,'SCREENEND');
      ListBox.Items.Insert(ListBox.ItemIndex,'');  //+ eine Leerzeile
     end else application.MessageBox('Bitte erst die Position in der Liste markieren, wo eingefgt werden soll.','Und wohin damit?',0);
end;

procedure TCreatorForm.RAMMONCHARButtonClick(Sender: TObject);
begin
     if (ListBox.ItemIndex>-1) or (ListBox.Items.Count>=0) then begin
      //in Liste hinzufgen:
      ListBox.Items.Insert(ListBox.ItemIndex,';Verlauf der RAM-Nutzung in den letzten 1.5 Minuten');
      ListBox.Items.Insert(ListBox.ItemIndex,'NEWSCREEN');
      ListBox.Items.Insert(ListBox.ItemIndex,'SELECTSCREEN 3');
      ListBox.Items.Insert(ListBox.ItemIndex,'CLEARSCREEN 1');
      ListBox.Items.Insert(ListBox.ItemIndex,'CLEARSCREEN 2');
      ListBox.Items.Insert(ListBox.ItemIndex,'LIGHT 1');
      ListBox.Items.Insert(ListBox.ItemIndex,'RAMMONCHAR');
      ListBox.Items.Insert(ListBox.ItemIndex,'SCREENTIME '+inttostr(ScreenTimeEdit.Value));
      ListBox.Items.Insert(ListBox.ItemIndex,'SCREENEND');
      ListBox.Items.Insert(ListBox.ItemIndex,'');  //+ eine Leerzeile
     end else application.MessageBox('Bitte erst die Position in der Liste markieren, wo eingefgt werden soll.','Und wohin damit?',0);
end;

procedure TCreatorForm.PrintersButtonClick(Sender: TObject);
begin
     if (ListBox.ItemIndex>-1) or (ListBox.Items.Count>=0) then begin
      //in Liste hinzufgen:
      ListBox.Items.Insert(ListBox.ItemIndex,';installierte Drucker');
      ListBox.Items.Insert(ListBox.ItemIndex,'NEWSCREEN');
      ListBox.Items.Insert(ListBox.ItemIndex,'CLEARSCREEN 2');
      ListBox.Items.Insert(ListBox.ItemIndex,'SELECTSCREEN 2');
      ListBox.Items.Insert(ListBox.ItemIndex,'LIGHT 1');
      ListBox.Items.Insert(ListBox.ItemIndex,'PRINTERS');
      ListBox.Items.Insert(ListBox.ItemIndex,'SCREENTIME '+inttostr(ScreenTimeEdit.Value));
      ListBox.Items.Insert(ListBox.ItemIndex,'SCREENEND');
      ListBox.Items.Insert(ListBox.ItemIndex,'');  //+ eine Leerzeile
     end else application.MessageBox('Bitte erst die Position in der Liste markieren, wo eingefgt werden soll.','Und wohin damit?',0);
end;

procedure TCreatorForm.DrivesButtonClick(Sender: TObject);
begin
     if (ListBox.ItemIndex>-1) or (ListBox.Items.Count>=0) then begin
      //in Liste hinzufgen:
      ListBox.Items.Insert(ListBox.ItemIndex,';Laufwerke');
      ListBox.Items.Insert(ListBox.ItemIndex,'NEWSCREEN');
      ListBox.Items.Insert(ListBox.ItemIndex,'CLEARSCREEN 2');
      ListBox.Items.Insert(ListBox.ItemIndex,'SELECTSCREEN 2');
      ListBox.Items.Insert(ListBox.ItemIndex,'LIGHT 1');
      ListBox.Items.Insert(ListBox.ItemIndex,'DRIVES');
      ListBox.Items.Insert(ListBox.ItemIndex,'SCREENTIME '+inttostr(ScreenTimeEdit.Value));
      ListBox.Items.Insert(ListBox.ItemIndex,'SCREENEND');
      ListBox.Items.Insert(ListBox.ItemIndex,'');  //+ eine Leerzeile
     end else application.MessageBox('Bitte erst die Position in der Liste markieren, wo eingefgt werden soll.','Und wohin damit?',0);
end;

procedure TCreatorForm.ExtLstButtonClick(Sender: TObject);
begin
     if openlistdialog.execute then begin
      if (ListBox.ItemIndex>-1) or (ListBox.Items.Count>=0) then begin
       //in Liste hinzufgen:
       ListBox.Items.Insert(ListBox.ItemIndex,';externe Liste einfgen:');
       ListBox.Items.Insert(ListBox.ItemIndex,'LOADSCREEN '+openlistdialog.FileName);
       ListBox.Items.Insert(ListBox.ItemIndex,'');  //+ eine Leerzeile
      end else application.MessageBox('Bitte erst die Position in der Liste markieren, wo eingefgt werden soll.','Und wohin damit?',0);
     end;
end;

procedure TCreatorForm.FormMouseMove(Sender: TObject; Shift: TShiftState;
  X, Y: Integer);
begin
     ShowHint(0);
end;

procedure TCreatorForm.ListBoxMouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
begin
     ShowHint(1);
end;

procedure TCreatorForm.ExtLstButtonMouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
begin
     ShowHint(2);
end;

procedure TCreatorForm.ShowHint(Nr: byte);
begin
     if HintNr<> Nr then begin
      HintNr:=Nr;
      HintMemo.Lines.Clear;
      case HintNr of
       1: begin
           HintMemo.Lines.Add('In dieser Liste stehen die Anweisungen an das Display, die von ''VFD-Studio'' verarbeitet werden.');
           HintMemo.Lines.Add('Diese Anweisungen sind zu Blcken zusammengefasst, die Screens genannt werden.');
           HintMemo.Lines.Add('Durch Mausklick auf die Liste wird die erste Anweisung des Screens (i.d.R. der Screentitel-Kommentar) markiert.');
           HintMemo.Lines.Add('Wenn diese Anweisung markiert ist kann der ganze Screen mit der ''Entf''-Taste gelscht werden.');
           HintMemo.Lines.Add('Hinweis: es kann immer nur vor dem markierten Screen ein anderer Screen eingefgt werden!');
          end;
       2: begin
           HintMemo.Lines.Add('Hier klicken und im folgenden Dateifenster eine andere Liste auswhlen um diese in die aktuelle Liste einzufgen.');
          end;
       3: begin
           HintMemo.Lines.Add('In dieser Liste stehen die Anweisungen des selbsterstellten Screens.');
           HintMemo.Lines.Add('Durch Mausklick auf die Liste kann ein Befehl markiert werden und mit der ''Entf''-Taste gelscht werden.');
           HintMemo.Lines.Add('Mit Klick auf ''<- in Liste einfgen'' kann der Screen in die aktuelle Liste eingefgt werden.');
           HintMemo.Lines.Add('Klicken auf ''Neuer Screen'' lscht den Screen.');
          end;
       4: begin
           HintMemo.Lines.Add('Hier klicken um einen neuen Screen zu erstellen.');
           HintMemo.Lines.Add('Achtung: die Aktionliste wird mit hierdurch gelscht!');
          end;
       5: begin
           HintMemo.Lines.Add('Klicken Sie hier um den Screen in die Liste einzufgen.');
          end;
       6: begin
           HintMemo.Lines.Add('Klicken Sie hier um aus den Eingaben, die Sie oben vorgenommen haben, einen Befehl zu erstellen, der der Screen-Liste hinzugefgt wird.');
           HintMemo.Lines.Add('Achtung: wechseln Sie auf eine andere Seite, so gehen Ihre Eingaben evtl. verloren!');
          end;
       7: begin
           HintMemo.Lines.Add('Und Tschss !?');
          end;
       8: begin
           HintMemo.Lines.Add('Hier klicken um eine neue Liste zu erstellen.');
           HintMemo.Lines.Add('Achtung: der Inhalt der Liste wird dabei gelscht!');
          end;
       9: begin
           HintMemo.Lines.Add('Klicken Sie hier um die Liste zu speichern.');
           HintMemo.Lines.Add('Stellen Sie dabei sicher unter einem Dateinamen mit der Endung ".LST" im zu speichern.');
           HintMemo.Lines.Add('Die Datei sollte zudem im "LISTS"-Verzeichnis liegen damit ''VFD-Studio'' fehlerfrei funktionieren kann.');
          end;
      10: begin
           HintMemo.Lines.Add('Hier klicken um eine Liste zu ffnen.');
           HintMemo.Lines.Add('Achtung: der Inhalt der Liste oben wird dabei berschrieben!');
          end;
      11: begin
           HintMemo.Lines.Add('Hier klicken um den CPU-Monitor-Screen in die Liste einzufgen.');
           HintMemo.Lines.Add('Dieser Screen zeigt den Verlauf der CPU-Belastung grafisch ber einen Zeitraum von ca. 8.5 Minuten an.');
           HintMemo.Lines.Add('Er sollte nicht verwendet werden, whrend Programme laufen, die hohe Systemressourcen bentigen (z.B. Spiele), da er die CPU selbst stark belasten kann.');
           HintMemo.Lines.Add('Zur Visualisierung der CPU-Last whrend Spielen o.. sollte stattdessen die 1.5 Minuten-Variante verwendet werden.');
           HintMemo.Lines.Add(' >>> Stellen Sie unten die Anzeigendauer dieses Screens ein bevor Sie hier klicken!');
          end;
      12: begin
           HintMemo.Lines.Add('Hier klicken um den CPU-Monitor-Screen in die Liste einzufgen.');
           HintMemo.Lines.Add('Dieser Screen zeigt den Verlauf der CPU-Belastung ber einen Zeitraum von ca. 1.5 Minuten an.');
           HintMemo.Lines.Add('Er bentigt deutlich weniger Systemressourcen als die 8.5 Minuten-Variante und kann daher auch verwendet werden um z.B. bei laufenden Spielen die');
           HintMemo.Lines.Add('CPU-Last anzuzeigen.');
           HintMemo.Lines.Add(' >>> Stellen Sie unten die Anzeigendauer dieses Screens ein bevor Sie hier klicken!');
          end;
      13: begin
           HintMemo.Lines.Add('Hier klicken um den RAM-Monitor-Screen in die Liste einzufgen.');
           HintMemo.Lines.Add('Dieser Screen zeigt den Verlauf der RAM-Nutzung grafisch ber einen Zeitraum von ca. 8.5 Minuten an.');
           HintMemo.Lines.Add('Dieser RAM-Monitor sollte nicht verwendet werden, whrend Anwendungen mit hohen Systemressourcenbedarf laufen.');
           HintMemo.Lines.Add('Verwenden Sie in diesem Fall lieber die 1.5 Minuten-Variante.');
           HintMemo.Lines.Add(' >>> Stellen Sie unten die Anzeigendauer dieses Screens ein bevor Sie hier klicken!');
          end;
      14: begin
           HintMemo.Lines.Add('Hier klicken um den RAM-Monitor-Screen in die Liste einzufgen.');
           HintMemo.Lines.Add('Dieser Screen zeigt den Verlauf der RAM-Nutzung ber einen Zeitraum von ca. 1.5 Minuten an.');
           HintMemo.Lines.Add('Er bentigt deutlich weniger Systemressourcen als die 8.5 Minuten-Variante und kann daher auch verwendet werden um z.B. bei laufenden Spielen die');
           HintMemo.Lines.Add('RAM-Last anzuzeigen.');
           HintMemo.Lines.Add(' >>> Stellen Sie unten die Anzeigendauer dieses Screens ein bevor Sie hier klicken!');
          end;
      15: begin
           HintMemo.Lines.Add('Hier klicken um den Drucker-Screen in die Liste einzufgen.');
           HintMemo.Lines.Add('Dieser Screen zeigt Informationen ber die ersten beiden Drucker des Rechners an.');
           HintMemo.Lines.Add('Hinweis: Sind mehr als zwei Drucker installiert, so werden nicht alle Gerte aufgelistet.');
           HintMemo.Lines.Add('');
           HintMemo.Lines.Add(' >>> Stellen Sie unten die Anzeigendauer dieses Screens ein bevor Sie hier klicken!');
          end;
      16: begin
           HintMemo.Lines.Add('Hier klicken um den Laufwerks-Screen in die Liste einzufgen.');
           HintMemo.Lines.Add('Dieser Screen zeigt Informationen ber alle installierten Laufwerke an, sowie eine bersicht.');
           HintMemo.Lines.Add('Wenn die Anzeigendauer dieses Screens nicht ausreicht alle Gerte aufzulisten, so wird beim nchsten Start dieses Screens die Auflistung fortgefhrt.');
           HintMemo.Lines.Add('');
           HintMemo.Lines.Add(' >>> Stellen Sie unten die Anzeigendauer dieses Screens ein bevor Sie hier klicken!');
          end;

      end; //case of

     end;
end;


procedure TCreatorForm.ScreenBoxMouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
begin
     ShowHint(3);
end;

procedure TCreatorForm.NewScreenButtonMouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
begin
     ShowHint(4);
end;

procedure TCreatorForm.AddScreenButtonMouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
begin
     ShowHint(5);
end;

procedure TCreatorForm.AddActionMouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
begin
     ShowHint(6);
end;

procedure TCreatorForm.ExitButtonMouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
begin
     ShowHint(7);
end;

procedure TCreatorForm.NewListButtonMouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
begin
     showHint(8);
end;

procedure TCreatorForm.SaveListButtonMouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
begin
     showHint(9);
end;

procedure TCreatorForm.LoadListButtonMouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
begin
     showHint(10);
end;

procedure TCreatorForm.CPUMONButtonMouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
begin
     showHint(11);
end;

procedure TCreatorForm.CPUMONCHARButtonMouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
begin
     showHint(12);
end;

procedure TCreatorForm.RAMMONButtonMouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
begin
     showHint(13);
end;

procedure TCreatorForm.RAMMONCHARButtonMouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
begin
     showHint(14);
end;

procedure TCreatorForm.PrintersButtonMouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
begin
     showHint(15);
end;

procedure TCreatorForm.DrivesButtonMouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
begin
     showHint(16);
end;

end.
